import bpy
import os

from .. import utils
from .. import constants

from .armor import THOMAS_RIG_ARMOR_ADD

class THOMAS_RIG_UPDATE_RIG(bpy.types.Operator):
    bl_idname = "thomasriglegacy.update_rig"
    bl_label = "update"
    bl_options = {'REGISTER', 'UNDO'}

    rig = None
    rig_version = None
    ext_version = None
    
    @classmethod
    def poll(cls, context):
        rig = utils.get_rig()

        if not rig or not rig.get("Rig_ID") == constants.RIG_ID:
            return False
        
        rig_version = rig.get("rig_version", "unknown")
        return rig_version == "unknown" or tuple(rig_version) < utils.get_ext_version()

    def execute(self, context):
        # self.rig = utils.get_rig()
        # self.rig_version = self.rig.get("rig_version", None)
        # self.ext_version = utils.get_ext_version()
        
        # if self.rig_version is None or tuple(self.rig_version) < (0, 2, 0):
        #     self.update_to_0_2_0()

        # if self.rig_version is None or tuple(self.rig_version) < (0, 2, 2):
        #     self.update_to_0_2_2()

        # set rig version to newest
        # self.rig["rig_version"] = self.ext_version
        # self.rig.data.update_tag()
        # bpy.context.view_layer.update()
        # self.report({"INFO"}, "Rig updated to v" + '.'.join(map(str, self.ext_version)))
        return {'FINISHED'}
    
    # def update_to_0_2_0(self):
    #     # hide eyes boolean
    #     for object in self.rig.children_recursive:
    #         if "Eyes" in object.name:
    #             object.modifiers["Boolean"].show_viewport = False
    #             break


    #     # Access Jaw constraint influence driver
    #     constraint = self.rig.pose.bones["Jaw"].constraints["LowEyes"]
    #     driver = constraint.driver_add("influence").driver

    #     # Add a new driver variable
    #     new_var = driver.variables.new()
    #     new_var.name = "low"
    #     new_var.type = "SINGLE_PROP"

    #     # Configure the new variable
    #     target = new_var.targets[0]
    #     target.id_type = "OBJECT"
    #     target.id = self.rig
    #     target.data_path = 'pose.bones["Eyes_UP_DOWN"].location[1]'

    #     # Set the driver expression
    #     driver.expression = "((1/(8*location-1)+1) *-low*5 if location<0 else 0)"


    #     # add chibi mode | property
    #     misc_props = self.rig.pose.bones["Misc_Properties"]
    #     misc_props["Chibi"] = False

    #     def add_chibi(target_bone_name, scale_factors):
    #         constraint = self.rig.pose.bones[target_bone_name].constraints.new(type="TRANSFORM")
    #         constraint.name = 'Chibi'
    #         constraint.target = self.rig
    #         constraint.subtarget = f'{self.rig.pose.bones["StaticBone"].name}'
    #         constraint.target_space = "LOCAL"
    #         constraint.owner_space = "LOCAL"
    #         constraint.map_to = "SCALE"
    #         constraint.to_min_x_scale = scale_factors
    #         constraint.to_max_x_scale = scale_factors
    #         constraint.to_min_y_scale = scale_factors
    #         constraint.to_max_y_scale = scale_factors
    #         constraint.to_min_z_scale = scale_factors
    #         constraint.to_max_z_scale = scale_factors
    #         constraint.mix_mode_scale = 'MULTIPLY'

    #         # add driver 1
    #         driver = constraint.driver_add("enabled").driver

    #         new_var = driver.variables.new()
    #         new_var.name = "chibi"
    #         new_var.type = "SINGLE_PROP"
    #         target = new_var.targets[0]
    #         target.id_type = "OBJECT"   
    #         target.id = self.rig
    #         target.data_path = 'pose.bones["Misc_Properties"]["Chibi"]'
    #         driver.expression = "chibi"

    #     add_chibi("Root", 2/3)
    #     add_chibi("Head", 1.25)

    # def update_to_0_2_2(self):
    #     def append_lattice(name):
    #         filepath = os.path.join(directory, name)
    #         bpy.ops.wm.append(
    #             filepath=filepath,
    #             filename=name,
    #             directory=directory,
    #             link=False,
    #             active_collection=True
    #         )

    #         lattice = bpy.context.selected_objects[0]
    #         lattice.hide_render = True
    #         lattice.hide_viewport = True
    #         utils.add_modifier_armature(self.rig, lattice)
    #         return lattice
        
    #     def set_modifier_arms(obj, rig, side):
    #         bpy.ops.object.select_all(action='DESELECT')
    #         bpy.context.view_layer.objects.active = obj
    #         obj.select_set(True)

    #         if side == "R":
    #             modifier = utils.add_modifier_lattice_arm_pose_R(rig, obj)
    #         else:
    #             modifier = utils.add_modifier_lattice_arm_pose_L(rig, obj)

    #         modifier.vertex_group = "Lattice"
    #         modifier.show_expanded = False

    #         while obj.modifiers.find(f"Arm_{side}") > 1:
    #             bpy.ops.object.modifier_move_up(modifier=f"Arm_{side}")


    #     bpy.ops.object.mode_set(mode='OBJECT')

    #     # lattice for chest mesh : duplicating current ont
    #     chest_lattice = utils.get_mat_object(self.rig).modifiers["Chest"].object
    #     new_lattice = chest_lattice.copy()
    #     new_lattice.data = chest_lattice.data.copy()
    #     new_lattice.name = "Chest_Pose"

    #     # link to the same collection
    #     for collection in chest_lattice.users_collection:
    #         collection.objects.link(new_lattice)

    #     # select lattice
    #     bpy.context.view_layer.objects.active = new_lattice
    #     new_lattice.select_set(True)

    #     # first move basis to last and remove all
    #     for _ in range(3):
    #         new_lattice.active_shape_key_index = 0
    #         bpy.ops.object.shape_key_move(type='DOWN')
    #         new_lattice.active_shape_key_index = 0
    #         bpy.ops.object.shape_key_remove(all=False)

    #     bpy.ops.object.shape_key_remove(all=False)
        
    #     # add lattice modifier for easier access in-script
    #     mat_obj = utils.get_mat_object(self.rig)
    #     mat_obj.modifiers.new(name = "Chest_Pose", type = "LATTICE")
    #     mat_obj.modifiers["Chest_Pose"].object = new_lattice
    #     mat_obj.modifiers["Chest_Pose"].show_viewport = False
    #     mat_obj.modifiers["Chest_Pose"].show_render = False
    #     mat_obj.modifiers["Chest_Pose"].show_expanded = False

    #     # increase lattice points
    #     new_lattice.data.points_u = 9
    #     new_lattice.data.points_v = 5
    #     new_lattice.data.points_w = 13

    #     # Create a new vertex group
    #     vertex_group = new_lattice.vertex_groups.new(name="UpperBodyMain")

    #     # Assign all lattice points to the new vertex group
    #     for i, point in enumerate(new_lattice.data.points):
    #         vertex_group.add([i], 1.0, 'ADD')

    #     # add armature modifier to new_lattice
    #     utils.add_modifier_armature(self.rig, new_lattice)

    #     # replace armature with lattice for chest
    #     objects = self.rig.children_recursive
    #     for obj in objects:
    #         if "Body" in obj.name:
    #             obj.modifiers.remove(obj.modifiers["Armature"])
    #             obj.modifiers.new(name = "Chest_Pose", type = "LATTICE")
    #             obj.modifiers["Chest_Pose"].object = new_lattice
    #             obj.modifiers["Chest_Pose"].show_expanded = False

    #             # Set the object as active and selected
    #             bpy.context.view_layer.objects.active = obj
    #             obj.select_set(True)

    #             # move to second inedex
    #             while obj.modifiers.find("Chest_Pose") > 1:
    #                 bpy.ops.object.modifier_move_up(modifier="Chest_Pose")

    #     # lattice for arms
    #     file = os.path.join(constants.MISC_PATH, "lattice_update.blend")
    #     directory = os.path.join(file, "Object")
        
    #     # append arm lattices
    #     arm_lattice_R = append_lattice("Lattice_Arm.R")
    #     arm_lattice_L = append_lattice("Lattice_Arm.L")
  
    #     # Unlink the object from its current collection(s)
    #     bpy.context.collection.objects.unlink(arm_lattice_R)
    #     bpy.context.collection.objects.unlink(arm_lattice_L)
                
    #     # Link the object to the target collection
    #     reference_object = utils.get_mat_object(self.rig).modifiers["Chest"].object
    #     for collection in bpy.data.collections:
    #         if reference_object.name in collection.objects:
    #             collection.objects.link(arm_lattice_R)
    #             collection.objects.link(arm_lattice_L)
    #             break

    #     # add lattice modifier for easier access in-script
    #     mat_obj = utils.get_mat_object(self.rig)
    #     mat_obj.modifiers.new(name = "Arm_R", type = "LATTICE")
    #     mat_obj.modifiers["Arm_R"].object = arm_lattice_R
    #     mat_obj.modifiers["Arm_R"].show_viewport = False
    #     mat_obj.modifiers["Arm_R"].show_render = False
    #     mat_obj.modifiers["Arm_R"].show_expanded = False

    #     # add lattice modifier for easier access in-script
    #     mat_obj = utils.get_mat_object(self.rig)
    #     mat_obj.modifiers.new(name = "Arm_L", type = "LATTICE")
    #     mat_obj.modifiers["Arm_L"].object = arm_lattice_L
    #     mat_obj.modifiers["Arm_L"].show_viewport = False
    #     mat_obj.modifiers["Arm_L"].show_render = False
    #     mat_obj.modifiers["Arm_L"].show_expanded = False

    #     # add bend driver
    #     THOMAS_RIG_ARMOR_ADD.add_driver_bend_120(None, arm_lattice_R, self.rig, ".R", "Bend", "arm_elbow", "a")
    #     THOMAS_RIG_ARMOR_ADD.add_driver_bend_120(None, arm_lattice_R, self.rig, ".R", "Bend2", "arm_elbow", "a")
    #     THOMAS_RIG_ARMOR_ADD.add_driver_bend_120(None, arm_lattice_R, self.rig, ".R", "120", "arm_elbow", "b")

    #     THOMAS_RIG_ARMOR_ADD.add_driver_bend_120(None, arm_lattice_L, self.rig, ".L", "Bend", "arm_elbow", "a")
    #     THOMAS_RIG_ARMOR_ADD.add_driver_bend_120(None, arm_lattice_L, self.rig, ".L", "Bend2", "arm_elbow", "a")
    #     THOMAS_RIG_ARMOR_ADD.add_driver_bend_120(None, arm_lattice_L, self.rig, ".L", "120", "arm_elbow", "b")

    #     # remove shapekeys set correct vertex group
    #     objects = self.rig.children_recursive
    #     for obj in objects:
    #         if "arm" in obj.name and obj.type == 'MESH':
    #             # remove bend shapekeys from arm objects
    #             if obj.data.shape_keys:
    #                 shape_keys = obj.data.shape_keys.key_blocks
    #                 for key in shape_keys:
    #                     if key.name in {"Bend", "120"}:
    #                         if key.driver_add("value"):
    #                             fcurves = key.id_data.animation_data.drivers
    #                             for fcurve in fcurves:
    #                                 if fcurve.data_path.endswith(f'["{key.name}"].value'):
    #                                     key.id_data.animation_data.drivers.remove(fcurve)
    #                         obj.shape_key_remove(key)

    #             # combine vertex groups
    #             # Create a new vertex group
    #             new_group = obj.vertex_groups.new(name="Lattice")

    #             # Get the indices of the vertices in the specified groups
    #             vertex_indices = set()

    #             # arm with fingers
    #             if any(["index" in group.name for group in obj.vertex_groups]):
    #                 for v in obj.data.vertices:
    #                     # z position threshold
    #                     if v.co.z >= -1:
    #                         vertex_indices.add(v.index)
    #             # arm without fingers     
    #             else:
    #                 vertex_indices.update([v.index for v in obj.data.vertices])
                
    #             # Add the vertices to the new group
    #             new_group.add(list(vertex_indices), 1.0, 'ADD')

    #             # set lattice modifier
    #             if "R." in obj.name.upper():
    #                 set_modifier_arms(obj, self.rig, "R")
    #             else:
    #                 set_modifier_arms(obj, self.rig, "L")

    #             # set mask to armature modifier
    #             for modifier in obj.modifiers:
    #                 if modifier.type == 'ARMATURE':
    #                     modifier.vertex_group = "Lattice"
    #                     modifier.invert_vertex_group = True
    #                     break

    #     # leg lattices
        
    #     def set_modifier_legs(obj, rig, side):
    #         bpy.ops.object.select_all(action='DESELECT')
    #         bpy.context.view_layer.objects.active = obj
    #         obj.select_set(True)

    #         if side == "R":
    #             modifier = utils.add_modifier_lattice_leg_pose_R(rig, obj)
    #         else:
    #             modifier = utils.add_modifier_lattice_leg_pose_L(rig, obj)

    #         modifier.vertex_group = "Lattice"
    #         modifier.show_expanded = False

    #         while obj.modifiers.find(f"Leg_{side}") > 1:
    #             bpy.ops.object.modifier_move_up(modifier=f"Leg_{side}")

    #     # lattice for arms
    #     file = os.path.join(constants.MISC_PATH, "lattice_update.blend")
    #     directory = os.path.join(file, "Object")
        
    #     # append arm lattices
    #     leg_lattice_R = append_lattice("Lattice_Leg.R")
    #     leg_lattice_L = append_lattice("Lattice_Leg.L")
  
    #     # Unlink the object from its current collection(s)
    #     bpy.context.collection.objects.unlink(leg_lattice_R)
    #     bpy.context.collection.objects.unlink(leg_lattice_L)
                
    #     # Link the object to the target collection
    #     reference_object = utils.get_mat_object(self.rig).modifiers["Chest"].object
    #     for collection in bpy.data.collections:
    #         if reference_object.name in collection.objects:
    #             collection.objects.link(leg_lattice_R)
    #             collection.objects.link(leg_lattice_L)
    #             break

    #     # add lattice modifier for easier access in-script
    #     mat_obj = utils.get_mat_object(self.rig)
    #     mat_obj.modifiers.new(name = "Leg_R", type = "LATTICE")
    #     mat_obj.modifiers["Leg_R"].object = leg_lattice_R
    #     mat_obj.modifiers["Leg_R"].show_viewport = False
    #     mat_obj.modifiers["Leg_R"].show_render = False
    #     mat_obj.modifiers["Leg_R"].show_expanded = False

    #     # add lattice modifier for easier access in-script
    #     mat_obj = utils.get_mat_object(self.rig)
    #     mat_obj.modifiers.new(name = "Leg_L", type = "LATTICE")
    #     mat_obj.modifiers["Leg_L"].object = leg_lattice_L
    #     mat_obj.modifiers["Leg_L"].show_viewport = False
    #     mat_obj.modifiers["Leg_L"].show_render = False
    #     mat_obj.modifiers["Leg_L"].show_expanded = False

    #     # add bend driver
    #     THOMAS_RIG_ARMOR_ADD.add_driver_bend_120(None, leg_lattice_R, self.rig, ".R", "LegBend", "Leg_knee", "a")
    #     THOMAS_RIG_ARMOR_ADD.add_driver_bend_120(None, leg_lattice_R, self.rig, ".R", "LegBend2", "Leg_knee", "b")
    #     THOMAS_RIG_ARMOR_ADD.add_driver_bend_120(None, leg_lattice_R, self.rig, ".R", "Leg120", "Leg_knee", "b")

    #     THOMAS_RIG_ARMOR_ADD.add_driver_bend_120(None, leg_lattice_L, self.rig, ".L", "LegBend", "Leg_knee", "a")
    #     THOMAS_RIG_ARMOR_ADD.add_driver_bend_120(None, leg_lattice_L, self.rig, ".L", "LegBend2", "Leg_knee", "b")
    #     THOMAS_RIG_ARMOR_ADD.add_driver_bend_120(None, leg_lattice_L, self.rig, ".L", "Leg120", "Leg_knee", "b")

    #     # remove shapekeys set correct vertex group
    #     objects = self.rig.children_recursive
    #     for obj in objects:
    #         if "leg" in obj.name.lower() and obj.type == 'MESH':
    #             # remove bend shapekeys from leg objects
    #             if obj.data.shape_keys:
    #                 shape_keys = obj.data.shape_keys.key_blocks
    #                 for key in shape_keys:
    #                     if key.driver_add("value"):
    #                         fcurves = key.id_data.animation_data.drivers
    #                         for fcurve in fcurves:
    #                             if fcurve.data_path.endswith(f'["{key.name}"].value'):
    #                                 key.id_data.animation_data.drivers.remove(fcurve)
    #                     obj.shape_key_remove(key)

    #             # combine vertex groups
    #             # Create a new vertex group
    #             new_group = obj.vertex_groups.new(name="Lattice")

    #             # Get the indices of the vertices in the specified groups
    #             vertex_indices = set()

    #             # arm with fingers
    #             if any(["index" in group.name for group in obj.vertex_groups]):
    #                 for v in obj.data.vertices:
    #                     # z position threshold
    #                     if v.co.z >= -1:
    #                         vertex_indices.add(v.index)
    #             # arm without fingers     
    #             else:
    #                 vertex_indices.update([v.index for v in obj.data.vertices])
                
    #             # Add the vertices to the new group
    #             new_group.add(list(vertex_indices), 1.0, 'ADD')

    #             # set lattice modifier
    #             if "R." in obj.name.upper():
    #                 set_modifier_legs(obj, self.rig, "R")
    #             else:
    #                 set_modifier_legs(obj, self.rig, "L")

    #             # remove armature modifier
    #             for modifier in obj.modifiers:
    #                 if modifier.type == 'ARMATURE':
    #                     obj.modifiers.remove(modifier)

    #     bpy.ops.object.select_all(action='DESELECT')
    #     bpy.context.view_layer.objects.active = self.rig
    #     self.rig.select_set(True)
    #     bpy.ops.object.mode_set(mode='POSE')